#include <stdio.h>
#include <stdlib.h>

  /* Kopiranje datoteke, znak po znak.
     Pogresno koristenje funkcije feof u petlji:
     Primjer 1 = do-while petlja. */

int main(int argc, char *argv[])
{
    FILE *in, *out;
    int c;    /* Ne: char c! */

    if (argc != 3) {    /* Nema imena datoteka! */
        fprintf(stderr, "Uporaba: %s ime1 ime2\n",
                argv[0]);
        exit(1);
    }

    if ((in = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Ne mogu citati: %s!\n",
                argv[1]);
        exit(2);
    }

    if ((out = fopen(argv[2], "w")) == NULL) {
        fprintf(stderr, "Ne mogu pisati: %s!\n",
                argv[2]);
        exit(3);
    }

    do {
        c = fgetc(in);
        fputc(c, out);
    } while (!feof(in));

    fclose(in);
    fclose(out);

    return 0;
}
